/*
 *  Lucidor - e-book reader
 *  Copyright © 2013  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("chrome://lucidor/content/utils.jsm");

const XHTML_NS = "http://www.w3.org/1999/xhtml";
const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var bid;
var bcase;

function init() {
    bid = window.arguments[0].bookinfo.id;
    bcase = window.arguments[0].bookcase;
    refresh();
}

function refresh() {
    let tagbox = document.getElementById("tags");
    while (tagbox.firstChild)
	tagbox.removeChild(tagbox.firstChild);
    for (let tag in loop(bcase.get_tags(bid)))
	append_tag(tag, tagbox);
}

function append_tag(label, box) {
    let div = document.createElementNS(XHTML_NS, "div");
    box.appendChild(div);
    div.appendChild(document.createTextNode(label));
    div.appendChild(document.createTextNode(" "));

    let link = document.createElementNS(XHTML_NS, "a");
    div.appendChild(link);
    link.setAttribute("href", "#");
    link.setAttribute("class", "button right");
    link.addEventListener("click", {
	label: label,
	div: div,
	handleEvent: function(e) { remove_tag(this.label, this.div); }
    }, false);
    let sharedbundle = document.getElementById("lucifox-shared_strings");
    let text = sharedbundle.getString("remove");
    link.appendChild(document.createTextNode("[" + text + "]"));
}

function remove_tag(label, div) {
    bcase.remove_tag(bid, label);
    div.parentNode.removeChild(div);
    //refresh();
}

function add() {
    let tb = document.getElementById("newtag");
    if (tb.value) {
	bcase.add_tag(bid, tb.value);
	append_tag(tb.value, document.getElementById("tags"));
	//refresh();
	tb.value = "";
    }
}

function unload() {
}
