/*
 *  Lucidor - e-book reader
 *  Copyright © 2009-2013  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

var EXPORTED_SYMBOLS = [ "enable_debug", "debug", "loop", "autohide", "iso_date" ];

var debug_enabled = true;

function enable_debug(val) {
    debug_enabled = val;
}

function debug(msg) {
    if (debug_enabled) {
	try {
	    let cons = Components.classes["@mozilla.org/consoleservice;1"].
		getService(Components.interfaces.nsIConsoleService);
	    cons.logStringMessage(msg);
	} catch (e) {
	}
    }
}

function loop(thing) {
    if (!thing)
	return;
    for (let i = 0; i < thing.length; i++)
	yield thing[i];
}

function autohide(elem, remove) {
    var tim = {
	notify: function(timer) {
	    try {
		if (remove) {
		    if (elem.close)
			elem.close();
		    else
			elem.parentNode.removeChild(elem);
		} else {
		    elem.hidden = true;
		}
	    } catch (e) {
	    }
	    this.timer = null;	// remove reference
	}
    };

    tim.timer = Components.classes["@mozilla.org/timer;1"].
	createInstance(Components.interfaces.nsITimer);
    tim.timer.initWithCallback(tim, 15000, tim.timer.TYPE_ONE_SHOT);
}

function iso_date(d) {
    //return d.toISOString();
    return '' + d.getUTCFullYear() + '-' +
	(101 + d.getUTCMonth()).toString().substring(1) + '-' +
	(100 + d.getUTCDate()).toString().substring(1) + 'T' +
	(100 + d.getUTCHours()).toString().substring(1) + ':' +
	(100 + d.getUTCMinutes()).toString().substring(1) + ':' +
	(100 + d.getUTCSeconds()).toString().substring(1) + 'Z';
}
