/*
 *  Lucidor - e-book reader
 *  Copyright © 2009-2013  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("chrome://lucidor/content/utils.jsm");
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function collectionManager() {
    this.wrappedJSObject = this;
    this.listeners = [];
}

collectionManager.prototype = {
    classDescription: "collectionManager",
    classID: Components.ID("{b0e946c7-5d40-4e17-94ca-654d3b29d974}"),
    contractID: "@lucidor.org/collectionManagerService;1",
    _xpcom_factory: collectionManagerFactory,
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports]),

    default_collections: [ 


			    { title: "Cullib",
			     type: "opds",
			     url: "http://coollib.net/opds",
			     icon: null },
			    { title: "Iknigi",
			     type: "opds",
			     url: "http://iknigi.net/opds/",
			     icon: null },
			    { title: "Litlib",
			     type: "opdsa",
			     url: "http://fb.litlib.net/odps",
			     icon:  null },
			    { title: "flibusta",
			     type: "opds",
			     url: " http://flibusta.is/opds",
			     icon: null },


/*			    { title: "Fantasy World",
			     type: "opds",
			     url: "http://f-w.in/opds",
			     icon: "http://f-w.in/opds/favicon.ico" },
			    { title: "LITLIB",
			     type: "opds",
			     url: "http://fb.litlib.net",
			     icon:  "http://fb.litlib.net/favicon.ico"},
			    { title: "Litlib",
			     type: "opds",
			     url: "http://fb.litlib.net",
			     icon: "http://fb.litlib.net/favicon.ico" },
			    { title: "Samizdat",
			     type: "opds",
			     url: "http://opdshome.uo1.net/samlib/",
			     icon: "http://opdshome.uo1.net/samlib//favicon.ico" },
			    { title: "Smartoff",
			     type: "opds",
			     url: "http://smartoff.net/opds/",
			     icon: "http://smartoff.net/opds/favicon.ico" },
			    { title: "Gutenberg ",
			     type: "opds",
			     url: "http://m.gutenberg.org",
			     icon: "http://m.gutenberg.org/favicon.ico" },
*/
			    /*
			    { title: "Bokselskap.no",
			     type: "opds",
			     url: "http://www.bokselskap.no/wp-content/themes/bokselskap/tekster/opds/root.xml",
			     icon: null },
			   { title: "Ebooks libres et gratuits",
			     type: "opds",
			     url: "http://www.ebooksgratuits.com/opds/",
			     icon: null },
			   { title: "Feedbooks",
			     type: "opds",
			     url: "http://feedbooks.com/catalog.atom",
			     icon: "http://www.feedbooks.com/favicon.ico" },
			   { title: "Internet Archive Catalog",
			     type: "opds",
			     url: "http://bookserver.archive.org/catalog/",
			     icon: "http://www.archive.org/favicon.ico" },
			    *
			   /*{ title: "Project Gutenberg",
			     type: "opds",
			     url: "http://lucidor.org/opds/pg.php",
			     icon: "http://lucidor.org/favicon.ico" },*/
			     /*
			   { title: "Smashwords",
			     type: "opds",
			     url: "http://www.smashwords.com/atom",
			     icon: null },
			    */
			   /*{ title: "Google Books",
			     type: "googlebooks" },
			   /*{ title: "epubcatalog.org",
			     type: "epubcatalog_atom" },*/
		           /*{ title: "Meta Catalog",
			     type: "opds",
			     url: "http://lucidor.org/opds/meta.atom" },*/

                     /*{ title: "Arxiv",
		         type: "opds",
		         url: "http://arxiv-opds.heroku.com/catalog.atom",
		         icon: "http://arxiv-opds.heroku.com/favicon.ico" },*/
		     /*{ title: "Internet Archive Aggregator",
			 type: "opds",
		         url: "http://bookserver.archive.org/aggregator/",
		         icon: "http://www.archive.org/favicon.ico" },*/
		     /*{ title: "PragPub Magazine",
			 type: "opds",
		         url: "http://pragprog.com/magazines.opds",
		         icon: "http://pragprog.com/favicon.ico" },*/
		     /*{ title: "Revues.org",
			 type: "opds",
		         url: "http://bookserver.revues.org/",
		         icon: "http://www.revues.org/favicon.ico" },*/
		     /*{ title: "Lucidor",
			 type: "opds",
		         url: "http://lucidor.org/opds/lucidor.php",
		         icon: "http://lucidor.org/favicon.ico" },*/
			   { title: "Local Sample Books",
			     type: "folder",
			     folder: "resource://lucidor/samples/" }
			 ],

    type_config: { epubcatalog_atom: { url: false, urls: false, folder: false,
				       auth: false },
		   folder: { url: false, urls: false, folder: true,
			     auth: false },
		   gutenberg_rdf: { url: true, urls: false, folder: false,
				    auth: false },
		   googlebooks: { url: false, urls: false, folder: false,
				  auth: false },
		   opds: { url: true, urls: false, folder: false,
			   auth: false },
		   stanza: { url: true, urls: false, folder: false,
			     auth: false },
		   opdss: { url: true, urls: false, folder: false,
			   auth: true },
		   webpage: { url: true, urls: false, folder: false,
			      auth: false } },

    getBookcase: function(coll, tree) {
	let bcase;
	if (coll.type == "local")
	    bcase = Components.classes["@lucidor.org/localCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "epubcatalog_atom")
	    bcase = Components.classes["@lucidor.org/epubcatalogCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "folder")
	    bcase = Components.classes["@lucidor.org/folderCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "googlebooks")
	    bcase = Components.classes["@lucidor.org/googlebooksCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "gutenberg_rdf")
	    bcase = Components.classes["@lucidor.org/gutenbergRDFCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "opds")
	    bcase = Components.classes["@lucidor.org/opdsCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "stanza")
	    bcase = Components.classes["@lucidor.org/stanzaCase;1"].
		createInstance().wrappedJSObject;
	else if (coll.type == "webpage")
	    bcase = Components.classes["@lucidor.org/webpageCase;1"].
		createInstance().wrappedJSObject;
	else
	    return null;
	bcase.init(coll, tree);
	return bcase;
    },

    hasCollections: function() {
	let prefs = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions.lucifox.");
	return prefs.prefHasUserValue("collection.order");
    },

    getCollections: function() {
	debug("getCollections");
	let prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.lucifox.");

	if (!prefs.prefHasUserValue("collection.order")) {
	    debug("Default");
	    return this.default_collections;
	}

	let value = prefs.getCharPref("collection.order");

	debug("ORDER: " + value);
	let order = JSON.parse(value);
	debug("Order: " + order);
	let collections = [];
	for (let num in loop(order.order)) {
	    try {
		value = prefs.getCharPref("collection." + num);
		let val = JSON.parse(value);

		if (val.type == "feedbooks_xml") {
		    // Backward-compatible glue
		    val = { title: "Feedbooks",
			    type: "opds",
			    url: "http://feedbooks.com/catalog.atom",
			    icon: "http://www.feedbooks.com/favicon.ico" };
		}

		collections.push(val);
	    } catch (e) {
	    }
	}
	return collections;
    },

    getOPDSCollectionsJSON3: function() {
	let ioService = Components.classes["@mozilla.org/network/io-service;1"].
		getService(Components.interfaces.nsIIOService);

	let collections = this.getCollections();
	let new_collections = [];
	for (let coll in loop(collections)) {
	    if (coll.type == "folder") {
		let uri = ioService.newURI(coll.folder, "UTF-8", null);
		let ncoll = { id: -1,
			      title: coll.title,
			      type: "opds",
			      url: "x-lucidor-opds://folder/?uri=" + encodeURIComponent(uri.spec),
			  icon: null };
		if (coll.id != undefined)
		    ncoll.id = coll.id;
		coll = ncoll;
	    } if (coll.type != "opds")
		continue;
	    if (coll.icon)
		new_collections.push([coll.title, JSON.stringify(coll),
				      coll.icon]);
	    else
		new_collections.push([coll.title, JSON.stringify(coll), null]);
	}
	return new_collections;
    },

    getCollectionsJSON: function() {
	return this.collectionsToJSON(this.getCollections());
    },

    getCollectionsJSON2: function() {
	return this.collectionsToJSON2(this.getCollections());
    },

    getCollectionsJSON3: function() {
	return this.collectionsToJSON3(this.getCollections());
    },

    getDefaultCollectionsJSON2: function() {
	return this.collectionsToJSON2(this.default_collections);
    },

    collectionsToJSON: function(collections) {
	debug("collectionsToJSON " + collections);
	let new_collections = [];
	for (let coll in loop(collections))
	    new_collections.push(JSON.stringify(coll));
	return new_collections;
    },

    collectionsToJSON2: function(collections) {
	debug("collectionsToJSON2 " + collections);
	let new_collections = [];
	for (let coll in loop(collections))
	    new_collections.push([coll.title, JSON.stringify(coll)]);
	return new_collections;
    },

    collectionsToJSON3: function(collections) {
	debug("collectionsToJSON3 " + collections);
	let new_collections = [];
	for (let coll in loop(collections)) {
	    if (coll.icon)
		new_collections.push([coll.title, JSON.stringify(coll),
				      coll.icon]);
	    else
		new_collections.push([coll.title, JSON.stringify(coll), null]);
	}
	return new_collections;
    },

    saveOrder: function(order) {
	debug("saveOrder " + order);
	let prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.lucifox.");
	let ord = { version: 1, order: order };
	prefs.setCharPref("collection.order", JSON.stringify(ord));
    },

    saveCollection: function(coll) {
	debug("saveCollection " + coll.id);
	let prefs = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.lucifox.");
	let old;
	try {
	    let pref = prefs.getCharPref("collection." + coll.id);
	    old = JSON.parse(pref);
	} catch (e) {
	}
	if (old) {
	    // FIXME
	}
	// FIXME check coll.type ...
	// delete coll.pass
	prefs.setCharPref("collection." + coll.id, JSON.stringify(coll));
    },

    saveCollectionsJSON2: function(collections) {
	let new_collection = [];
	for (let coll in loop(collections))
	    new_collection.push(coll[1]);
	return this.saveCollectionsJSON(new_collection);
    },

    saveCollectionsJSON: function(collections) {
	debug("saveCollectionsJSON: " + collections);
	let prefservice = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	let prefs = prefservice.getBranch("extensions.lucifox.");
	let old_order = [];
	try {
	    let pref = prefs.getCharPref("collection.order");
	    old_order = JSON.parse(pref).order;
	} catch (e) {
	}

	debug("1");

	let next_id = 1;
	for (let num in loop(old_order))
	    if (num >= next_id)
		next_id = num + 1;

	debug("2");

	let order = [];
	for (let coll in loop(collections)) {
	    let co = JSON.parse(coll);
	    if (co.id == undefined)
		co.id = next_id++;
	    else if (old_order)
		for (let i = 0; i < old_order.length; i++)
		    if (old_order[i] == co.id) {
			old_order[i] = -1;
			break;
		    }
	    debug("** " + order);
	    this.saveCollection(co);
	    order.push(co.id);
	}
	this.saveOrder(order);

	debug("3");

	prefservice.savePrefFile(null);
	this.tellListeners();

	debug("4");

	for (let id in loop(old_order))
	    if (id != -1)
		this.removeCollection(id);

	prefservice.savePrefFile(null);
    },

    tellListeners: function() {
	for (let li in loop(this.listeners)) {
	    if (li.reread_collections)
		li.reread_collections();
	    // FIXME else remove listener?
	}
    },

    changeCollectionDB: function(collid, db) {
	debug("changeCollectionDB");
	let prefservice = Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService);
	let prefs = prefservice.getBranch("extensions.lucifox.");
	let coll;
	try {
	    let pref = prefs.getCharPref("collection." + collid);
	    coll = JSON.parse(pref);
	} catch (e) {
	}
	if (!coll)
	    return -1;
	coll.db = db.getFilename();
	prefs.setCharPref("collection." + coll.id, JSON.stringify(coll));
	prefservice.savePrefFile(null);
	debug("changeCollectionDB finished");
	return 0;
    },

    // NOTE Does not change collection.order
    removeCollection: function(id) {
	let prefservice = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService);
	let prefs = prefservice.getBranch("extensions.lucifox.");
	try {
	    let pref = prefs.getCharPref("collection." + id);
	    let old = JSON.parse(pref);
	    if (old.db) {
		let file = Components.classes["@mozilla.org/file/directory_service;1"].
		    getService(Components.interfaces.nsIProperties).
		    get("ProfD", Components.interfaces.nsIFile);
		file.append(old.db + ".sqlite");
		file.remove(false);
	    }
	} catch (e) {
	    debug("E: " +  e);
	}
	prefs.clearUserPref("collection." + id);

	prefservice.savePrefFile(null);
	this.tellListeners();
    },

    maybeAddCollection: function(coll) {
	let prefservice = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService);
	let prefs = prefservice.getBranch("extensions.lucifox.");
	if (!prefs.prefHasUserValue("collection.order"))
	    return;
	let value = prefs.getCharPref("collection.order");
	let order = JSON.parse(value);
	let collections = [];
	for (let num in loop(order.order)) {
	    try {
		value = prefs.getCharPref("collection." + num);
		let val = JSON.parse(value);

		if (val.type != coll.type)
		    continue;
		if ((val.url != undefined) && (coll.url != undefined) &&
		    (val.url != coll.url))
		    continue;
		if ((val.folder != undefined) && (coll.folder != undefined) &&
		    (val.folder != coll.folder))
		    continue;
		return;
	    } catch (e) {
	    }
	}
	this.addCollection(coll);
    },

    addCollection: function(coll) {
	let prefservice = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService);
	let prefs = prefservice.getBranch("extensions.lucifox.");

	// Use empty list of collections if none exists
	if (!prefs.prefHasUserValue("collection.order"))
	    this.saveOrder([]);

	let pref = prefs.getCharPref("collection.order");
	let order = JSON.parse(pref);
	let no = 0;
	for (let ord in loop(order.order))
	    if (ord >= no)
		no = ord + 1;
	coll.id = no;
	prefs.setCharPref("collection." + coll.id, JSON.stringify(coll));
	order.order.push(no);
	prefs.setCharPref("collection.order", JSON.stringify(order));

	prefservice.savePrefFile(null);
	this.tellListeners();
    },

    getConfig: function(type) {
	return this.type_config[type];
    },

    addListener: function(li) {
	this.listeners.push(li);
    },

    removeListener: function(li) {
	// FIXME
    }
};

var serviceObject = new collectionManager();

var collectionManagerFactory = {
    createInstance: function(outer, aIID) {
	if (outer != null)
	    throw Components.results.NS_ERROR_NO_AGGREGATION;
	return serviceObject.QueryInterface(aIID);
    }
};

var components = [collectionManager];

if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
