/*
 *  Lucidor - e-book reader
 *  Copyright © 2008-2014  Mikael Ylikoski
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

Components.utils.import("chrome://lucidor/content/utils.jsm");
Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const XHTML_NS = "http://www.w3.org/1999/xhtml";
const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

function mainControl() {
    this.wrappedJSObject = this;
    this.tempfiles = [];
    this.tempdir = null;
}

mainControl.prototype = {
    classDescription: "mainControl",
    classID: Components.ID("{df75f575-2d91-444f-adca-b6e01eaecf03}"),
    contractID: "@lucidor.org/mainControlService;1",
    _xpcom_factory: mainControlFactory,
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports]),

    init: function(win) {
	this.main_window = win;
    },

    online: function() {
	return this.main_window.navigator.onLine;
    },

    add_tab: function(location) {
	return this.main_window.add_tab(location);
    },

    add_epub_tab: function(location, root) {
	return this.main_window.add_epub_tab(location, root);
    },

    add_web_tab: function(location) {
	return this.main_window.add_web_tab(location);
    },

    add_web_tab_post: function(location, post) {
	return this.main_window.add_web_tab_post(location, post);
    },

    open_epub_location: function(location) {
	return this.main_window.open_epub_location(location);
    },

    open_location: function(location) {
	return this.main_window.open_location(location);
    },

    update_bar: function() {
	return this.main_window.update_bar();
    },

    update_tab_title: function(win) {
	return this.main_window.update_tab_title(win);
    },

    toggle_tabbar: function() {
	return this.main_window.toggle_tabbar();
    },

    update_notes: function() {
	return this.main_window.update_notes();
    }
};

var serviceObject = new mainControl();

var mainControlFactory = {
    createInstance: function(outer, aIID) {
	if (outer != null)
	    throw Components.results.NS_ERROR_NO_AGGREGATION;
	return serviceObject.QueryInterface(aIID);
    }
};

var components = [mainControl];

if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
